﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{

	import flash.events.TextEvent;
	import flash.external.ExternalInterface;
	import flash.events.MouseEvent;

	import com.actionscriptfacile.ui.text.UITextField;
	import com.facebook.graph.Facebook;

	import flash.display.Sprite;
	import flash.events.Event;

	import com.demonsters.debugger.MonsterDebugger;

	public class Main extends Sprite
	{
		private static const APP_ID : String = "252125291482906";
		
		private var oFacebookSessionUser : Object;
		private var opts : Object;
		
		private var oTxtLoggin : UITextField;
		private var oTxtFriends : UITextField;
		private var oTxtInfos : UITextField;
		private var oTxtPublishStatus : UITextField;
		
		private var oBtnLoggin : DefaultButton;
		private var oTxtFriendDetails : UITextField;
		


		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 * http://apps.facebook.com/actionscript-facil
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");

			setupUi();

			// les options de récupération possible des données utilisateur
			opts = {perms:"publish_stream, user_photos, user_birthday, read_stream"};
			Facebook.init(APP_ID, handleInit, opts);// Initialize Facebook library
		}

		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			oTxtLoggin = new UITextField();
			oTxtLoggin.x = 10;
			oTxtLoggin.y = 10;
			oTxtLoggin.maxWidth = oTxtLoggin.width = 420;
			oTxtLoggin.htmlText = "...";
			oTxtLoggin.autoSizeLeft();
			// redimensionnement automatique du champ texte
			oTxtLoggin.wordWrap = true;
			oTxtLoggin.convertToDynamic();
			oTxtLoggin.alignLeft();

			oTxtLoggin.changeFormat("size", 11);
			oTxtLoggin.changeFormat("font", "Arial");
			oTxtLoggin.changeFormat("color", Math.random() * 0X00FFFFFF);


			oBtnLoggin = new DefaultButton();
			oBtnLoggin.getObject().label = "...";
			oBtnLoggin.getObject().x = oTxtLoggin.x + oTxtLoggin.maxWidth + 10;
			oBtnLoggin.getObject().y = oTxtLoggin.y;
			oBtnLoggin.getObject().addEventListener(MouseEvent.CLICK, onLoginClick);
			
			var oBtnAddStatus:DefaultButton = new DefaultButton();
			oBtnAddStatus.getObject().label = "Valider Status";
			oBtnAddStatus.getObject().x = oBtnLoggin.getObject().x;
			oBtnAddStatus.getObject().y = oBtnLoggin.getObject().y + oBtnLoggin.getObject().height + 10;
			oBtnAddStatus.getObject().addEventListener(MouseEvent.CLICK, onAddStatus);
			
			var oBtnHideFriendDetail:DefaultButton = new DefaultButton();
			oBtnHideFriendDetail.getObject().label = "Cacher Ami";
			oBtnHideFriendDetail.getObject().x = oBtnLoggin.getObject().x;
			oBtnHideFriendDetail.getObject().y = oBtnAddStatus.getObject().y + oBtnAddStatus.getObject().height + 10;
			oBtnHideFriendDetail.getObject().addEventListener(MouseEvent.CLICK, onHideFriendDetails);
		
			
			oTxtInfos = new UITextField();
			oTxtInfos.x = oTxtLoggin.x;
			oTxtInfos.maxWidth = oTxtInfos.width = oTxtLoggin.maxWidth;
			oTxtInfos.htmlText = "...";
			oTxtInfos.autoSizeLeft();
			// redimensionnement automatique du champ texte
			oTxtInfos.wordWrap = true;
			oTxtInfos.convertToDynamic();
			oTxtInfos.alignLeft();

			oTxtInfos.changeFormat("size", 11);
			oTxtInfos.changeFormat("font", "Arial");
			oTxtInfos.changeFormat("color", Math.random() * 0X00FFFFFF);
			
			oTxtPublishStatus = new UITextField();
			oTxtPublishStatus.x = oTxtLoggin.x;
			oTxtPublishStatus.maxWidth = oTxtPublishStatus.width = oTxtLoggin.maxWidth + 150;
			oTxtPublishStatus.height = 30;
			oTxtPublishStatus.background = true;
			oTxtPublishStatus.backgroundColor = 0x006f77;
			oTxtPublishStatus.text = "Publier un status : \n\n";
			oTxtPublishStatus.autoSizeLeft();
			// redimensionnement automatique du champ texte
			oTxtPublishStatus.wordWrap = true;
			oTxtPublishStatus.convertToInput();
			oTxtPublishStatus.alignLeft();

			oTxtPublishStatus.changeFormat("size", 11);
			oTxtPublishStatus.changeFormat("font", "Arial");
			oTxtPublishStatus.changeFormat("color", Math.random() * 0X00FFFFFF);
			
			
			oTxtFriends = new UITextField();
			oTxtFriends.x = oTxtInfos.x;
			oTxtFriends.maxWidth = oTxtFriends.width = oTxtLoggin.maxWidth + 150;
			oTxtFriends.background = false;
			oTxtFriends.backgroundColor = 0x006f77;
			oTxtFriends.htmlText = " <b>Liste de vos amis en cours de chargement ...</b> ";
			oTxtFriends.autoSizeLeft();
			oTxtFriends.addEventListener(TextEvent.LINK, getFriendDetails);
			// redimensionnement automatique du champ texte
			oTxtFriends.wordWrap = true;
			oTxtFriends.convertToDynamic();
			oTxtFriends.alignLeft();

			oTxtFriends.changeFormat("size", 11);
			oTxtFriends.changeFormat("font", "Arial");
			oTxtFriends.changeFormat("color", Math.random() * 0X00FFFFFF);
			
			
			oTxtFriendDetails = new UITextField();
			oTxtFriendDetails.x = oTxtFriendDetails.x;
			oTxtFriendDetails.y = 50;
			oTxtFriendDetails.maxWidth = oTxtFriendDetails.width = oTxtLoggin.maxWidth;
			oTxtFriendDetails.background = true;
			oTxtFriendDetails.backgroundColor = 0x006f77;
			oTxtFriendDetails.htmlText = "...";
			oTxtFriendDetails.autoSizeLeft();
			// redimensionnement automatique du champ texte
			oTxtFriendDetails.wordWrap = true;
			oTxtFriendDetails.convertToDynamic();
			oTxtFriendDetails.alignLeft();

			oTxtFriendDetails.changeFormat("size", 11);
			oTxtFriendDetails.changeFormat("font", "Arial");
			oTxtFriendDetails.changeFormat("color", Math.random() * 0X00FFFFFF);
			
			oTxtFriendDetails.visible = false;
			
			addChild(oTxtInfos);
			addChild(oTxtLoggin);
			addChild(oTxtPublishStatus);
			addChild(oTxtFriends);
			addChild(oTxtFriendDetails);
			addChild(oBtnLoggin);
			addChild(oBtnAddStatus);
			addChild(oBtnHideFriendDetail);
			
			this.posTxt();
		}


		/**
		 * Cache la fenêtre qui affiche les informations détaillées d'un ami.
		 * 
		 */
		private function onHideFriendDetails(event : MouseEvent) : void
		{
			oTxtFriendDetails.visible = false;
		}
		

		/**
		 * Clique sur le lien ActionScript.
		 * Récupère et affiche les informations détaillées de l'ami sélectionné.
		 * 
		 */
		private function getFriendDetails(event : TextEvent) : void
		{
			MonsterDebugger.trace(this, "getFriendDetails");
			MonsterDebugger.trace(this, event.text);

			var aDataFriend:Array = new Array();
			aDataFriend = event.text.split(",");
			
			MonsterDebugger.trace(this, aDataFriend);
			
			Facebook.api('/'+aDataFriend[0], getFriendsDetails);
		}
		
		
		/**
		 * Click sur le bouton Login.
		 * 
		 */
		private function onLoginClick(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onLoginClick");

			if (Facebook.getSession() && Facebook.getSession().accessToken == null)
			{
				// erreur de login
				MonsterDebugger.trace(this, "erreur de login - publish_stream");
				Facebook.login(handleInit, opts);
			}
			else
			{
				MonsterDebugger.trace(this, "Déconnection de Facebook");
				Facebook.logout(onLogout);
			}
		}
		
		
		/**
		 * Mise à jour du status Facebook de l'utilisateur.
		 * 
		 */
		private function onAddStatus(event : MouseEvent) : void
		{
			Facebook.api("/me/feed",submitStatusHandler,{message:oTxtPublishStatus.text}, "POST");
		}


		/**
		 * Chargement des informations de l'utilisateur.
		 * 
		 */
		protected function loadUserInfo() : void
		{
			Facebook.api('/me', onMyInfoLoaded);
		}

		
		/**
		 * Positionnement automatique des textes
		 * pour éviter qu'il se chevauche.
		 * 
		 */
		private function posTxt():void
		{
			oTxtInfos.y = oTxtLoggin.y + oTxtLoggin.height;
			oTxtPublishStatus.y = oTxtInfos.y + oTxtInfos.height;
			oTxtFriends.y = oTxtPublishStatus.y + oTxtPublishStatus.height;
		}
		
		
			
		/**
		 * Données Facebook de l'utilisateur.
		 * Récupération de ses amis, favoris...
		 * 
		 * 
		 */
		protected function loadUIList() : void
		{
			var aUserData : Array = new Array();
			
			// les amis de l'utilisateur
			aUserData["/me/friends"] = new Array();
			aUserData["/me/friends"] = getUIType('/me/friends');
			
			// le status en cours de l'utilisateur - historique des statut de l'utilisateur
			aUserData["/me/statuses"] = new Array();
			aUserData["/me/statuses"] = getUIType('/me/statuses');
		}
		
		
		/**
		 * Récupération des infos de l'utilisateur.
		 * 
		 */
		protected function getUIType(type : String) : void
		{
			switch(type)
			{
				case '/me/friends':
					Facebook.api('/me/friends', getFriendsHandler);
					break;
					
				case '/me/statuses':
					Facebook.api('/me/statuses', getStatusHandler);
					break;
					
				default:
					break;
			}
		}
		
/********************************************************************/
/*************** Données Facebook de l'utilisateur.  ****************/
/*************** Récupération de ses amis, favoris... ***************/
/********************************************************************/


		/**
		 * Appel par Facebook.
		 * Initialisation des données utilisateur Facebook.
		 * 
		 */
		public function handleInit(oFacebookSession : Object, fail : Object) : void
		{
			MonsterDebugger.trace(this, "handleLogin");
			MonsterDebugger.trace(this, oFacebookSession);
			
			// sauvegarde des données utilisateur
			oFacebookSessionUser = oFacebookSession;
			
			/**
			 * Données utilisateur disponibles :
			 * accessToken
			 * secret
			 * sessionKey
			 * sig
			 * uid
			 * 
			 */
			
			if (oFacebookSessionUser)
			{
				// Utilisateur connecté à Facebook
				oTxtLoggin.htmlText = "Connecté ;)";
				oBtnLoggin.getObject().label = "Se déconnecter";
				loadUserInfo();
			}
			else
			{
				oTxtLoggin.htmlText = "Vous n'êtes pas connecté.";
				ExternalInterface.call('redirect');
				// redirection vers la page de connection
			}
			this.posTxt();
		}
		
		
		/**
		 * Appel par Facebook.
		 * Récupère les informations de l'utilisateur Facebook connecté.
		 * 
		 */
		protected function onMyInfoLoaded(oUser : Object, fail : Object) : void
		{
			MonsterDebugger.trace(this, "onMyInfoLoaded");
			MonsterDebugger.trace(this, oUser);
			/**
			 * Données disponibles : 
			 * bio : champ à propos de vous
			 * name : le pseudo complet
			 * first_name : le prénom
			 * last_name : le nom de famille
			 * gender : homme ou femme
			 * hometown.name : la ville de naissance
			 * location.name : la ville actuelle
			 * quotes : la citation préférée
			 * work : tableau contenant les données personnelles (travail...)
			 * 
			 */
			
			var sUrlPictureProfile:String =  "<img src='"+Facebook.getImageUrl(oFacebookSessionUser.uid, "small")+"' >";
			 
			oTxtLoggin.htmlText = "Connecté ;) comme <b>" + oUser.name + "</b>." +
			sUrlPictureProfile+"\n"+
			"Vous venez de <b>" + oUser.hometown.name + "</b>.\n" +
			"Actuellement, vous vivez à <b>" + oUser.location.name + "</b>.\n" + "" +
			"Vous êtes un(e) <b>" + oUser.gender + "</b>.\n" +
			"Vous vous définissez comme :\n<b>" + oUser.bio + "</b>\n" +
			"Votre citation préférée est : <b>" + oUser.quotes + "</b>" ;
			
			this.posTxt();
			loadUIList();// charge certaines informations de l'utilisateur.
		}


		/**
		 * Appel par Facebook lorsque la déconnection de l'utilisateur est réussie.
		 * 
		 */
		protected function onLogout(success : Boolean) : void
		{
			MonsterDebugger.trace(this, "onLogout réussie !");
			oTxtLoggin.htmlText = "Déconnecté";
			oBtnLoggin.getObject().label = "Se connecter";
			loadUserInfo();
		}
		
		
		/**
		 * Appel par Facebook suite à la mise à jour du status de l'utilisateur.
		 * 
		 */
		protected function submitStatusHandler(result:Object,fail:Object):void
		{
			MonsterDebugger.trace(this, "submitStatusHandler");
			oTxtPublishStatus.text = "---> Status mis à jour !";
		}
		
	
		
		/**
		 * Appel par Facebook.
		 * Envoie du status en cours de l'utilisateur.
		 * 
		 */
		protected function getStatusHandler(aStatus:Object, fail:Object):void
		{
			MonsterDebugger.trace(this, "--> getStatusHandler");
			MonsterDebugger.trace(this, aStatus);
			
			/**
			 * aStatus[] est un tableau qui contient les status facebook de l'utilisateur.
			 * aStatus[0].message
			 */
			oTxtInfos.htmlText = "<b>Votre Status : </b>"  + aStatus[0].message;
			this.posTxt();
		}
		
		
		/**
		 * Appel par Facebook.
		 * Envoie la liste de tous les amis de l'utilisateur.
		 * 
		 */
		protected function getFriendsHandler(response:Object, fail:Object):void
		{
			MonsterDebugger.trace(this, "--> getFriendsHandler");
			MonsterDebugger.trace(this, response);
			
			var sContent:String;
			var aFriend:Array = response as Array;
			/**
			 * aFriend[] est un tableau qui contient les amis facebook de l'utilisateur.
			 * aFriend[0].id : identifiant de l'ami
			 * aFriend[0].name : Prénom et nom de l'ami
			 * 
			 */
			sContent = "Vous avez <b>"+aFriend.length+" amis :</b>   ";
			
			
			for (var i : int = 0; i < aFriend.length; i++) 
			{
				sContent += "<a href=\"event:"+aFriend[i].id+","+aFriend[i].name+"\">"+aFriend[i].name + "</a>, ";
				if(i>73)	break;
			}	
			oTxtFriends.htmlText = sContent;
		}
		
		
		/**
		 * Appel par Facebook.
		 * Affiche les informations détaillés d'un ami de l'utilisateur.
		 * 
		 */
		protected function getFriendsDetails(response:Object, fail:Object):void
		{
			MonsterDebugger.trace(this, "--> getFriendsDetails");
			MonsterDebugger.trace(this, response);
			
			var oData:Object = response;
			/**
			 * oData est un objet qui contient les informations d'un ami facebook de l'utilisateur.
			 * name : son prénom avec le nom
			 * link : le lien de son profil facebook
			 * gender : une femme ou un homme
			 * id : son id facebook
			 * 
			 */
			
			var sUrlPictureProfile:String =  "<img src='"+Facebook.getImageUrl(oData.id, "large")+"' >";
			
			oTxtFriendDetails.htmlText = " "+oData.name+" est un(e) " + oData.gender+"\n " +
			"<a href=\""+ oData.link + "\" target=\"_blank\"><b>Découvrez son profil facebook</b></a>"+sUrlPictureProfile;
			
			oTxtFriendDetails.visible = true;
		}
	}
}
